package com.example.waluty;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Objects;

public class Rate {
    private final String code;
    private final String currency;
    private final BigDecimal mid;

    public Rate(String code, String currency, BigDecimal mid) {
        this.code = code;
        this.currency = currency;
        this.mid = mid;
    }

    public String getCode() {
        return code;
    }

    public String getCurrency() {
        return currency;
    }

    public BigDecimal getMid() {
        return mid;
    }

    @Override
    public String toString() {
        return code + " (" + currency + "): " + mid;
    }

    @Override
    public boolean equals(Object o) {
        if (o == null || getClass() != o.getClass()) return false;
        Rate rate = (Rate) o;
        return Objects.equals(code, rate.code) && Objects.equals(currency, rate.currency) && Objects.equals(mid, rate.mid);
    }

    @Override
    public int hashCode() {
        return Objects.hash(code, currency, mid);
    }

    public BigDecimal przeliczNaZlote(BigDecimal kwota) {
        return kwota.multiply(mid).setScale(2, RoundingMode.HALF_EVEN);
    }

    public BigDecimal przeliczNaWalute(BigDecimal kwota) {
        // w przypadku dzielenie od razu podajemy oczekiwaną precyzję i sposób zaokrąglania
        return kwota.divide(mid, 2, RoundingMode.HALF_EVEN);
    }
}
